import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class ControlCanvas extends ScaleCanvas implements MouseListener, KeyListener {
    AffineTransform A;
    Manager M;
    ListenSquare[] FUNCTION;
    ControlPanel MAIN,PROOF1,DEBUG,EXPORT,STRONG,PRESET;
    SelectInteger[] RANGE=new SelectInteger[2];
    EnergyCombo[] ENG=new EnergyCombo[6];
    ListenSquare GO,HALT;
    TestPosdom1 TP1;
    TestPosdom2 TP2;
    Debug DEB;
    PopupManager PM;
    PosdomMonitor POSM;
    CustomPowerCombo CPC;
    ListenSquare INFO1,INFO2,INFO3,INFO4;

     public ControlCanvas() {
	 addMouseListener(this);
	 addMouseMotionListener(this);
	 addKeyListener(this);
	 setActionControls();
	 setEnergyControls();
	 setFunctionControls();	
	 ControlPanelSetup.main(this);
	 String[] S={"0","0","0","0","0","0"};
	 CPC=new CustomPowerCombo(400,10,S);
	 PM=new PopupManager(this.M,510,50);
	 POSM=new PosdomMonitor(this.M,310,180,260,260);
	 INFO1=new ListenSquare(303,5,12,12);   //TBP-FP competition
	 INFO3=new ListenSquare(0,5,12,12);
	 INFO4=new ListenSquare(530,25,12,12);  //popups
     }


      public void setActionControls() {
	 GO=new ListenSquare(0,170,30,30);
	 HALT=new ListenSquare(30,170,40,30);
	 TP1=new TestPosdom1();
	 TP2=new TestPosdom2();
	 DEB=new Debug();
    }

    /**The other buttons for this console are drawn in the
       DrawCompetition routine below. */

    
    public void setEnergyControls() {
         Color[] C1={new Color(200,0,0),Color.white,Color.white};
	 Color[] C2={new Color(0,0,200),Color.white,Color.white};
	 int[] p={50,100,200,300};
  	 for(int i=0;i<6;++i) ENG[i]=new EnergyCombo(25+25*i,"");
	 PresetData.preset0(ENG);
    }

    public void setFunctionControls() {
	 RANGE[0]=new SelectInteger(5,225,35,20,-2,-2,16,1);
	 RANGE[1]=new SelectInteger(78,225,35,20,0,-2,16,1);
    }


   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
       g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
       RenderingHints.VALUE_ANTIALIAS_ON);
       drawFrame(g);
       drawControls(g);
   }

    public void drawFrame(Graphics2D g) {
	g.setColor(new Color(60,80,100));
	g.fillRect(0,0,getWidth(),getHeight());
	PM.render(g);
	INFO1.infoRender(g);
	INFO3.infoRender(g);
	INFO4.infoRender(g);
    }

    
    public void drawControls(Graphics2D g) {
	MAIN.render(g,0,279,80);
	EXPORT.render(g,0,364,80);
	PRESET.render(g,210,279,90);
	if(MAIN.mode<2) {
	    PROOF1.render(g,85,279,120);
	    STRONG.render(g,85,365,120);
	}
	g.setColor(Color.white);
	g.setFont(new Font("Helvetica",Font.PLAIN,14));
	g.drawString("hybrid energy console",40,15);
	if(MAIN.mode==3) DEBUG.render(g, 85,279,120);
	drawGo(g);
	drawHalt(g);
	drawComboControl(g);
	drawRange(g);
	if(MAIN.mode==2) POSM.render(g);
	if(MAIN.mode==1) CPC.render(g,new Color(255,140,255));
    }

    public void drawRange(Graphics2D g) {
	for(int i=0;i<2;++i) 
        RANGE[i].render(g,Color.red,Color.white,Color.white);
	g.drawString("posdom test domain",10,260);
	g.drawString("min",14,220);
	g.drawString("max",85,220);
    }

    public void drawComboControl(Graphics2D g) {
	Color[] C=PresetData.colorScheme();
	for(int i=0;i<5;++i) ENG[i].render(g,C[i]);
	drawCompetition(g);
    }

    public void drawCompetition(Graphics2D g) {
	int[] list=TestNumerical.main(this.M);
	Color[] COL={new Color(50,100,255),new Color(255,0,0),new Color(200,0,200)};
	for(int i=0;i<5;++i) {
	    g.setColor(COL[list[i]]);
	    g.fillRect(300,25+25*i,20,20);
	    g.setColor(Color.white);
	    g.drawRect(300,25+25*i,20,20);

	}
    }



    public void drawGo(Graphics2D g) {
	if(TP1.HALT==false) return;   
	if(TP2.HALT==false) return;   
        g.setFont(new Font("Helvetica",Font.PLAIN,18));
	GO.render(g,new Color(0,150,0));
	g.drawString("go",(int)(GO.x+4),(int)(GO.y+20));
    }

    public void drawHalt(Graphics2D g) {
	boolean running=false;
	if(TP1.HALT==false) running=true;
	if(TP2.HALT==false) running=true;
	if(DEB.HALT==false) running=true;
	if(running==false) return;
        g.setFont(new Font("Helvetica",Font.PLAIN,18));
	HALT.render(g,new Color(200,0,0));
	g.drawString("stop",(int)(HALT.x+4),(int)(HALT.y+20));
    }


    public void doHalt() {
	TP1.HALT=true;
	TP2.HALT=true;
	DEB.HALT=true;
    }

    public void doGo() {
	if(TP1.HALT==false) return;
	if(TP2.HALT==false) return;
	int mode=MAIN.mode;
	if(mode==0) doGo1();
	if(mode==1) doGo2();
	if(mode==2) doGo3();
	if(mode==3) doGo4();
    }

    public void doGo1() {
        TP1=new TestPosdom1(this.M);
        new Thread(TP1).start();
    }

    public void doGo3() {
	TP2=new TestPosdom2(this.M);
        new Thread(TP2).start();
    }
    
    public void doGo2() {
	TP1=new TestPosdom1(this.M);
	new Thread(TP1).start();
    }
    

    public void doGo4() {
	DEB=new Debug(this.M);
        new Thread(DEB).start();
    }



    public void mouseClicked(MouseEvent e) {
        MouseData J=MouseData.process(e);
	for(int i=0;i<6;++i) ENG[i].process(e);
	if(MAIN.mode==1) CPC.process(e);
	for(int i=0;i<2;++i) RANGE[i].modify(J.X);
	functionControls(J.X);
	if(MAIN.mode<2) PROOF1.switchMode(J.X);
	if(MAIN.mode==3) DEBUG.switchMode(J.X);
	MAIN.switchMode(J.X);
	STRONG.switchMode(J.X);
	EXPORT.switchMode(J.X);
	PM.M=this.M;
	PM.process(J.X);
	if(GO.inside(J.X)==1) doGo();
	if(HALT.inside(J.X)==1) doHalt();
	resetDebug();
	documentStuff(J.X);
	doTest();
	M.repaint();
    }

    public void doTest() {

    }

  public void documentStuff(Point X) {
      if(MAIN.L[20].inside(X)==1) DocumentControl.test(M.D);
      if(INFO1.inside(X)==1) DocumentControl.compete(M.D);
      if(INFO3.inside(X)==1) DocumentControl.combo(M.D);
      if(INFO4.inside(X)==1) DocumentControl.popups(M.D);
      if(DEBUG.L[20].inside(X)==1) DocumentControl.debug(M.D);
      if(EXPORT.L[20].inside(X)==1) DocumentControl.export(M.D);
      if((MAIN.mode==0)&&(PROOF1.L[20].inside(X)==1))  DocumentControl.mode1(M.D);
      if((MAIN.mode==0)&&(STRONG.L[20].inside(X)==1))  DocumentControl.mode2(M.D);
      if(PRESET.L[20].inside(X)==1) DocumentControl.preset(M.D);
    }

    public void functionControls(Point X) {
	PRESET.switchMode(X);
	int t=PRESET.getValue(X);

	if(t==0) {
	    PresetData.preset0(this.M);
	    STRONG.forceMode(0);
	    PROOF1.forceMode(0);
	    MAIN.forceMode(0);
	}
	
	if(t==1) {
	    PresetData.preset1(this.M);
	    STRONG.forceMode(0);
	    PROOF1.forceMode(1);
	    MAIN.forceMode(0);
	}
	
	if(t==2) {
	    PresetData.preset2(this.M);
	    STRONG.forceMode(1);
	    PROOF1.forceMode(1);
	    MAIN.forceMode(0);
	}
	
	if(t==3) {
	    PresetData.preset3(this.M);
	    STRONG.forceMode(1);
	    PROOF1.forceMode(1);
	    MAIN.forceMode(0);
	}

	if(t==4) {
	    PresetData.preset4(this.M);
	    STRONG.forceMode(0);
	    PROOF1.forceMode(1);
	    MAIN.forceMode(1);
	}

	if(t==5) {
	    PresetData.preset5(this.M);
	    STRONG.forceMode(1);
   	    PROOF1.forceMode(1);
	    MAIN.forceMode(1);
	}

	if(t==6) {
	    PresetData.preset6(this.M);
	    STRONG.forceMode(1);
	    PROOF1.forceMode(1);
	    MAIN.forceMode(1);
	}

	if(t==7) {
	    PresetData.preset7(this.M);
	    STRONG.forceMode(1);
	    PROOF1.forceMode(1);
	    MAIN.forceMode(1);
	}
	
    }

    public double[] getTarget() {
      double[] A={Math.sqrt(2),Math.sqrt(3),2};
      return A;
    }


    public void mouseDragged(MouseEvent e) {
        MouseData J=MouseData.process(e);
        resetDebug();
	M.repaint();
    }

    public void mousePressed(MouseEvent e) {}
     public void mouseReleased(MouseEvent e) {}
     public void mouseEntered(MouseEvent e) {}
     public void mouseExited(MouseEvent e) {}   

    public void keyTyped(KeyEvent e) {
	for(int i=0;i<5;++i) {
	  ENG[i].processKey(e);
	}
	CPC.processKey(e);
	M.repaint();
    }
 
    public void keyPressed(KeyEvent e) {}
    public void keyReleased(KeyEvent e) {}

    public void resetDebug() {
	try {
	    M.P.DEBUG1=null;
	    M.P.DEBUG2=null;
	    M.P.repaint();
	}
	catch(Exception e) {}
    }

}

