import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;

/**Documentation file*/


public class DocumentIntro {

    public DocumentIntro() {}


    public static void setup(DocumentCanvas D) {
    
	String S="The Energy Hybrid Analyzer\n\n";
        S=S+"Richard Evan Schwartz\n";
	S=S+"program started: 1 July 2016\n";
	S=S+"Last updated:  24 Dec 2022\n";


	S=S+"\n\nPURPOSE:\n\n";
	S=S+"This program is a companion to my monograph called `Divide and Conquer: A Distributed Approsch to Energy Minimization'.  The program allows you to run the proofs of the results in the part of the monograph called Interpolation.  The main result of this part is Lemma A2.  The basic idea is that we can select 5 energy hybrids (defined in the monograph) and we want to see that a suitable linear combination of them under-approximates a power-law potential.";

	    S=S+"\n\nOPERATING INSTRUCTIONS\n\n";

	    S=S+"This window gives explanations for the rest of the program.  Drag the mouse over the text to scroll up or down. (There is more text than what is now visible.) The text in this window will change if you press some of the black ?-boxes sprinkled throughout the rest of the program. If you want to return this text, press the black ?-box at top left.";

	    S=S+"\n\nWhen this program opens, it shows two windows, this one and a control panel.  On the control panel, there is a console which allows you to bring up  two additional windows, called `Approx' and 'Coeffs'.  You should try bringing these windows up, then deleting them, then bringing them up again, just to see how this control works. These windows have their own documentation.";


	    S=S+"\n\nThis program is designed to work best with a 3 button mouse. On the picture window, buttoms 1 and 3 zoom in and out of the picture and button 2 selects a new point. If you don't have a 3 button mouse, you can use the keyboard buttons z,x,c or the buttons b,n,m to simulate the 3 buttons when you are operating any of the windows where you might want to rescale the picture.  The keyboard replacements are a bit touchy. If you move your cursor into a window from outside the window, you will need to click on the window (to activate it) before being able to successfully use the keyboard replacements.";

	    S=S+"\n\nOVERVIEW OF THE WINDOWS:";

	    S=S+"\n\ncontrol panel: This is the window from which you launch the programs. You should click the ?-boxes to learn more about what it does.  The main thing the window does is allow you to select 5 energy combos, e.g. \n\nG0 (the function that is identically 1)\n\n G1\n\nG2\n\nG5\n\nG10+28G5+102G2\n\nIf this doesn't make sense to you then you should read the first chapter in part 2 of the monograph.   In the monograph I described the results in terms of a pair of energy hybrids.  This pair fits inside a quintuple, with the first three always being G0, G1, G2.  Thus, for instance, one of the pairs (G4,G6) in the monograph is part of the quintuple (G0,G1,G2,G4,G6).  With the main control panel you can modify the quintuple as you like and then see the plots of the coefficients.   ";

	    S=S+"\n\ndocument: This is the window you are currently looking at.";

	    S=S+"\n\nCompare: This window plots the comparison function \n\n(1-\u0393/F)\n\n from the Interpolation part of the monograph. We want this function to be non-negative on [0,2] and 0 at the values \u221A 2, \u221A 3, \u221A 4.  We also scale the range of the plot so that it fits nicely in the window.   We also plot the negative of this function for the energy quintuple (G0,G1,G2,G4,G5) because this one has to do with the power law exponents in the range (-2,0).  I omitted this part from the monograph because it was annoying to have to keep track of both signs all the time.  But, in the program, the user can see how this part works.";

	    S=S+"\n\nCoeff: This window pertains to Lemmas A221, A231, A232.  These results pertain to the positivity of certain coefficients on certain intervals.  This window plots these coefficients.   The positivity, of course, is only guaranteed for the quintuples corresponding to the pairs from the monograph.";

        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;
    }
}

