import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;

/**This is the graphics part of the program. It draws
   the little window*/

public class ControlCanvas extends Canvas implements MouseListener {
    ListenSquare GO,DEBUG;
    ControlPanel MAIN;

    
     public ControlCanvas() {
	 addMouseListener(this);
	 GO=new ListenSquare(0,0,50,40);
	 DEBUG=new ListenSquare(0,45,50,40);
	 setUp();
     }

    /**Sets up the control panel, giving the test options*/
    public void setUp() {
     Color[] C0={new Color(50,150,255),Color.white,Color.white,Color.black,Color.red};
     
     String[] MainString={"Lemma A221 case 1","Lemma A221 case 2", "Lemma A221 case 3","A222 small","A222 big","Lemma choice"};
     int[] MainState={1,0,0,0,0};
      MAIN=new ControlPanel(C0,MainString,MainState,5);
      MAIN.mode=0;
    }


    /**draws the window*/
   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
      g.setColor(Color.black);
      g.fillRect(0,0,getWidth(),getHeight());
      drawControls(g);
   }

    
    /**Draws the control panel*/
   public void drawControls(Graphics2D g) {
      GO.render(g,Color.green);
      DEBUG.render(g,Color.white);
      g.setColor(Color.black);
      g.setFont(new Font("Helvetica",Font.PLAIN,14));
      g.drawString("GO",(int)(GO.x+5),(int)(GO.y+25));
      g.drawString("debug",(int)(DEBUG.x+5),(int)(DEBUG.y+25));
      MAIN.render(g,60,0,140);
    }
    
    /**This launches the tests*/    
    public void doGo() {
	int m=MAIN.mode;
	if(m==0) RunTests.lemmaA221(0);
	if(m==1) RunTests.lemmaA221(1);
	if(m==2) RunTests.lemmaA221(2);
	if(m==3) RunTests.lemmaA222Small();
	if(m==4) RunTests.lemmaA222Big();
    }


    /**processes mouse events*/
    
    public void mouseClicked(MouseEvent e) {
        MouseData J=MouseData.process(e);
	if(GO.inside(J.X)==1) doGo();
	if(DEBUG.inside(J.X)==1) Debugger.main();
	MAIN.switchMode(J.X);
	repaint();
    }
    
    public void mousePressed(MouseEvent e) {}
     public void mouseReleased(MouseEvent e) {}
     public void mouseEntered(MouseEvent e) {}
     public void mouseExited(MouseEvent e) {}   


}

