import java.applet.Applet;
import java.awt.event.*;
import java.awt.*;
import java.math.*;


public class RigorousPower {
    
    /**Here is the controlled power function
       sign=-1 gives an under-approximation and
       sign=+1 gives an over-approximation.  The routine
       uses floating point arithmetic to make a guess. Then,
       after the guess is made, it is rigorously checked
       using exact arithmetic.  The checker is very slow.*/

    public static BigRational pow(int sign,BigRational A,BigRational E) {
	double a=A.toDouble();
	double e=E.toDouble();
	double x=Math.pow(a,e);
	double u=Math.pow(2,32)*x;
	long n=(long)(u);
	Long N=new Long(n+2*sign);
	BigRational X=new BigRational(N.toString(),"4294967296");// 2^32
	X.reduce();
	int test=BigRational.testPow(A,E,X);
	if(test!=sign) throw new ProofException("problem with power function");
	return X;
    }
    
}


    
